// ------------------------------------------------------------------
//	Class	TTitleIcon
//	Base	TIcon
//
// This class derives an icon whose appearance is a 14x1 rectangle
//	with shadow, with the attached TMinWindow's title.
// ------------------------------------------------------------------

const cmIconsEat =	100;

#if defined( Uses_TTitleIcon ) && !defined( __TTitleIcon )
#define __TTitleIcon

class far TEvent;
class far opstream;
class far ipstream;
class far TStreamable;

class TTitleIcon : public TIcon
	{
	public:

		TTitleIcon();

		virtual void handleEvent( TEvent& event );
		virtual void draw();

	private:

		virtual const char *streamableName() const
			{ return name; }

	protected:

		TTitleIcon( StreamableInit );
		virtual void write( opstream& os );
		virtual void *read( ipstream& is );

	public:

		static const char * const near name;
		static TStreamable *build();

	};

inline ipstream& operator >> ( ipstream& is, TTitleIcon& cl )
	{ return is >> (TStreamable&)cl; }
inline ipstream& operator >> ( ipstream& is, TTitleIcon*& cl )
	{ return is >> (void *&)cl; }

inline opstream& operator << ( opstream& os, TTitleIcon& cl )
	{ return os << (TStreamable&)cl; }
inline opstream& operator << ( opstream& os, TTitleIcon* cl )
	{ return os << (TStreamable *)cl; }


#endif	// __TTitleIcon

/*---------------------------------------------------------*/
/*                                                         */
/*   Turbo Vision 1.0                                      */
/*   Copyright (c) 1991 by Borland International           */
/*                                                         */
/*   Fileview.h:  Header file for fileview.cpp.            */
/*---------------------------------------------------------*/

/***********************************************************/
/*	NOTE: minor mods have been made to this file (part of  */
/*	the TVDEMO demo programs included with TV) to support  */
/*  a minimizing window.                                   */
/***********************************************************/

/********* Old code
#if !defined( __FILEVIEW_H )
#define __FILEVIEW_H

#define Uses_TCollection
#define Uses_TScroller
#define Uses_TWindow
#include <tv.h>
**********************/

/************************  Added  **************************/
#if defined( Uses_TFileWindow ) && !defined( __TFileWindow )
#define __TFileWindow
/***********************************************************/

const hlChangeDir = cmChangeDir;

class TLineCollection : public TCollection
{

public:

	TLineCollection(short lim, short delta) : TCollection(lim, delta) {}
	virtual void  freeItem(void *p) { delete p; }

private:

	virtual void *readItem( ipstream& ) { return 0; }
	virtual void writeItem( void *, opstream& ) {}

};

class TFileViewer : public TScroller
{

public:

	char *fileName;
	TCollection *fileLines;
	Boolean isValid;
	TFileViewer( const TRect& bounds,
				 TScrollBar *aHScrollBar,
				 TScrollBar *aVScrollBar,
				 const char *aFileName
			   );
	~TFileViewer();
	TFileViewer( StreamableInit ) : TScroller(streamableInit) { };
	void draw();
	void readFile( const char *fName );
	void setState( ushort aState, Boolean enable );
	void scrollDraw();
	Boolean valid( ushort command );

private:

	virtual const char *streamableName() const
		{ return name; }

protected:

    virtual void write( opstream& );
    virtual void *read( ipstream& );

public:

    static const char * const name;
    static TStreamable *build();

};

/***************************  Added ************************/
/*	The base class for TFileWindow has been changed to     */
/*	TMinWindow.                                            */
/***********************************************************/

class TFileWindow : public TMinWindow
{

public:

	TFileWindow( const char *fileName );

};

const int maxLineLength = 256;

#endif

#if defined( Uses_TDemoApp ) && !defined( __TDemoApp )
#define __TDemoApp

class far TMenuBar;
class far TStatusLine;
class far TDeskTop;
class far TEvent;

class TDemoApp : public TApplication
	{
	public:

		TDemoApp();

		static TMenuBar *initMenuBar( TRect r );
		static TStatusLine *initStatusLine( TRect r );
		static TDeskTop *initDeskTop( TRect r );

		virtual void handleEvent( TEvent& event );
	};

#endif	// __TDemoApp

// ------------------------------------------------------------------
//	Class	TTitleDeskTop
//	Base	TWinDeskTop
//
// This is a demo class that is similar to TDeskTop except that
//	it sorts the icons by filename and arranges them along the
//	bottom of the desktop.
// ------------------------------------------------------------------

#if defined( Uses_TTitleDeskTop ) && !defined( __TTitleDeskTop )
#define __TTitleDeskTop

class far TRect;
class far TEvent;

class TTitleDeskTop : public TDeskTop
	{
	public:
		TTitleDeskTop( const TRect& bounds );

		virtual void handleEvent( TEvent& event );
		virtual void arrangeIcons();
	};

#endif	// __TTitleDeskTop
