#define Uses_TMinFrame
#define Uses_TDrawBuffer
#define Uses_TWindow
#define Uses_TRect
#define Uses_TPoint
#define Uses_TStreamable
#define Uses_TGroup
#define Uses_TEvent
#define Uses_IconCommands
#define Uses_TStreamableClass
#include "main.h"

#if !defined( __STRING_H )
#include <string.h>
#endif

__link( RFrame )
const char * const near TMinFrame::name = "TMinFrame";
TStreamableClass RMinFrame( TMinFrame::name, TMinFrame::build,
	__DELTA(TMinFrame) );

// Members required for drawing the zoom icons.

const char *TMinFrame::maxZoomIcon =  "[~\x19\x12~]";
const char *TMinFrame::normZoomIcon = "[~\x19\x18~]";

TMinFrame::TMinFrame( const TRect& bounds ) :
		TFrame(bounds)
	{
	}

void TMinFrame::handleEvent( TEvent& event )
	{
	TView::handleEvent(event);

	// Handle minimize clicks.

	if( event.what== evMouseDown && (state & sfActive) != 0 )
		{
		TPoint mouse = makeLocal( event.mouse.where );
		if( mouse.y == 0 )
			if( (((TWindow *)owner)->flags & wfZoom) != 0 &&
			  ( (mouse.x >= size.x - 6 && mouse.x <= size.x - 5) ) )
				{
				event.what= evCommand;
				event.message.command = cmMinimize;
				event.message.infoPtr = owner;
				putEvent( event );
				clearEvent( event );
				}
		}
	TFrame::handleEvent(event);
	}

void TMinFrame::draw()
	{

	// Same as TFrame::draw(), except that the zoom icon strings are
	//	one char longer.

	ushort cFrame, cTitle;
	short  f, i, l, width;
	TDrawBuffer b;
	Boolean isMaximized;

	TPoint minSize, maxSize;
	owner->sizeLimits( minSize, maxSize );
	isMaximized = Boolean( owner->size == maxSize );

	// Set colors.

	if( (state & sfActive) == 0 )
		{
		cFrame = 0x0101;
		cTitle = 0x0002;
		f = 0;
		}
	else
		if( (state & sfDragging) != 0 )
			{
			cFrame = 0x0505;
			cTitle = 0x0005;
			f = 0;
			}
		else
			{
			cFrame = 0x0503;
			cTitle = 0x0004;
			f = 9;
			}
	cFrame = getColor(cFrame);
	cTitle = getColor(cTitle);

	width = size.x;
	l = width - 10;

	minFrameLine( b, 0, f, uchar(cFrame) );

	if( ( ((TWindow *)owner)->flags & (wfClose | wfZoom) ) != 0 )
		l -= 7;
	if( ((TWindow *)owner)->number != wnNoNumber &&
		((TWindow *)owner)->number < 10
	  )
		{
		l -= 4;
		if( ( ((TWindow *)owner)->flags & wfZoom ) != 0 )
			i = 8;
		else
			i = 3;
		b.putChar( width-i, ((TWindow *)owner)->number + '0' );
		}

	if( owner != 0 )
		{
		const char *title = ((TWindow *)owner)->getTitle(l);
		if( title != 0 )
			{
			l = min( cstrlen(title), width - 10 );
			l = max( l, 0 );
			i = (width - l) >> 1;
			b.putChar( i-1, ' ' );
			b.moveBuf( i, title, cTitle, l );
			b.putChar( i+l, ' ' );
			}
		}

	if( (state & sfActive) != 0 )
		{
		if( ( ((TWindow *)owner)->flags & wfClose ) != 0 )
			b.moveCStr( 2, minCloseIcon, cFrame );
		if( ( ((TWindow *)owner)->flags & wfZoom ) != 0 )
			{
			if( isMaximized )
				b.moveCStr( width-6, maxZoomIcon, cFrame );
			else
				b.moveCStr( width-6, normZoomIcon, cFrame );
			}
		}

	writeLine( 0, 0, size.x, 1, b );
	for( i = 1; i <=  size.y - 2; i++ )
		{
		minFrameLine( b, i, f +  3, cFrame );
		writeLine( 0, i, size.x, 1, b );
		}
	minFrameLine( b, size.y - 1, f +  6, cFrame );

	if( (state & sfActive) != 0 )
		if( ( ((TWindow *)owner)->flags & wfGrow ) != 0 )
			b.moveCStr( width-2, minDragIcon, cFrame );
	writeLine( 0, size.y - 1, size.x, 1, b );
	}

TMinFrame::TMinFrame( StreamableInit ) : TFrame( streamableInit )
	{
	}

TStreamable *TMinFrame::build()
	{
	return new TMinFrame( streamableInit );
	}

// Members that mimic those in TFrame (those are private and cant access).

static char FrameMask[132];
const char TMinFrame::minInitFrame[19] =
  "\x06\x0A\x0C\x05\x00\x05\x03\x0A\x09\x16\x1A\x1C\x15\x00\x15\x13\x1A\x19";
char TMinFrame::minFrameChars[33] =
	"          ϻ "; // for UnitedStates code page
const char *TMinFrame::minCloseIcon = "[~\xFE~]";
const char *TMinFrame::minDragIcon = "~~";

//	This method is the C++ equivalent of the assembly TFrame::frameLine().

void TMinFrame::minFrameLine( TDrawBuffer& frameBuf, short y, short n, uchar color )
	{
	char *src = (char *)minInitFrame + n;
	FrameMask[0] = *src;
	memset( FrameMask+1, src[1], size.x-2 );
	FrameMask[size.x-1] = src[2];

	TView *pv = owner->last;
	uchar alo, ahi;

	while( (pv = pv->next) != this )
		{
		if( (pv->options & ofFramed) == 0 || (pv->state & sfVisible) == 0 )
			continue;

		short sy = y - pv->origin.y;
		if( sy < 0 )
			{
			sy++;
			if( sy != 0 )
				continue;
			ahi = 10;
			alo = 6;
			}
		else if( sy > pv->size.y )
			continue;
		else if( sy == pv->size.y )
			{
			ahi = 10;	alo = 3;
			}
		else
			{
			ahi = 0;
			alo = 5;
			}
		short ox = pv->origin.x;
		short n = pv->size.x + ox;
		if( ox < 1 )
			ox = 1;
		if( n > size.x )
			n = size.x;
		if( ox >= n )
			continue;
		FrameMask[ox-1] |= alo;
		alo ^= ahi;
		FrameMask[n] |= alo;
		if( ahi == 0 )
			continue;

		n -= ox;
		do	{
			FrameMask[ox++] |= ahi;
			n--;
			}
		while( n != 0 );
		}

	n = size.x+1;
	short indent = 0;
	src = FrameMask;
	do	{
		frameBuf.moveChar( indent++, minFrameChars[*src++], color, 1 );
		n--;
		}
	while( n != 0 );
	}
