#define Uses_TTitleIcon
#define Uses_TMinWindow
#define Uses_TFilterWindow
#define Uses_TRect
#define Uses_TEvent
#define Uses_TDrawBuffer
#define Uses_FCommands
#define Uses_TStreamable
#define Uses_opstream
#define Uses_ipstream
#define Uses_TStreamableClass
#include "main.h"

#if !defined( __STRING_H )
#include <string.h>
#endif

__link( RIcon )
const char * const near TTitleIcon::name = "TTitleIcon";
TStreamableClass RTitleIcon( TTitleIcon::name, TTitleIcon::build,
  __DELTA(TTitleIcon) );

TTitleIcon::TTitleIcon() : TIcon( TRect(0,0,14,1) )
	{

	// Add shadow to the window.

	state |= sfShadow;
	eventMask |= evCommand;
	}

void TTitleIcon::handleEvent( TEvent& event )
	{
	TIcon::handleEvent(event);

	if( event.what == evCommand &&
		event.message.command == cmIconsEat )
		clearEvent(event);
	}

// Draw the icon. Colors used are those that the TFrame uses. The
//	appearance of the icon is a 14x1 rectangle with the linked
//	window's title (first 12 characters).

void TTitleIcon::draw()
	{
	TDrawBuffer b;
	ushort color;

	if( (state & sfSelected) == 0 )
		color = 0x0101;
	else
		if( (state & sfDragging) != 0 )
			color = 0x0303;
		else
			color = 0x0302;
	color = getColor(color);

	b.moveChar( 0, ' ', color, size.x );
	if( link != 0 && link->title != 0 )
		{
		char *title = newStr( link->getTitle(12) );
		if( strlen(title) > 12 )
			title[12] = 0;
		b.moveStr( 1+(12-strlen(title))/2, title, color );
		delete title;
		}
	writeLine( 0, 0, size.x, size.y, b );
	}

TTitleIcon::TTitleIcon( StreamableInit ) : TIcon( streamableInit )
	{
	}

void TTitleIcon::write( opstream& os )
	{
	TIcon::write(os);
	}

void *TTitleIcon::read( ipstream& is )
	{
	TIcon::read(is);
	return this;
	}

TStreamable *TTitleIcon::build()
	{
	return new TTitleIcon( streamableInit );
	}
